Leetcode62. 不同路径(HOT100)

链接

我的代码:

cpp 复制代码
class Solution {
public:
    int uniquePaths(int m, int n) {
        if(m<=1||n<=1)return 1;
        vector<vector<int>> dp(m,vector<int>(n));
        for(int i = 0;i<m;i++){
            for(int j = 0;j<n;j++){
                if(!i&&!j)dp[i][j] = 0;
                else if(!i||!j)dp[i][j] = 1;
                else dp[i][j] = dp[i-1][j]+dp[i][j-1];
            }
        }
        return dp[m-1][n-1];
    }
};

空间优化为O(N):

cpp 复制代码
class Solution {
public:
    int uniquePaths(int m, int n) {
        vector<int> f(n,1);
        for(int i = 1;i<m;i++){
            for(int j = 1;j<n;j++){
                f[j] +=f[j-1];
            }
        }
        return f[n-1];
    }
};


//空间O(N),时间O(m*n)
// 动态规划数组f:
// 使用一维数组 f 来存储每一列的路径数。数组大小为 n,表示当前行的路径数。
// 初始化 f 为 1,表示从起点 (0, 0) 到达任意第一行或第一列的路径数都是 1(因为只能直走)。
// 循环更新路径数:
// 外层循环 for (int i = 1; i < m; i++) 遍历每一行,从第二行开始,因为第一行已经初始化。
// 内层循环 for (int j = 1; j < n; j++) 遍历每一列,从第二列开始。
// f[j] = f[j] + f[j - 1]; 这行代码的核心逻辑:
// f[j] 表示到达位置 (i, j) 的路径数。
// 这个值是由上方位置 (i-1, j) 的路径数(即 f[j])和左侧位置 (i, j-1) 的路径数(即 f[j-1])相加得来的。
// 因此,f[j] 更新为当前格子路径数的总和。
相关推荐
xiangyun618 分钟前
C++ priority_queue 底层:手撕二叉堆与 Top K 问题
c++·算法·面试·stl·1024程序员节
qz_Serene1 小时前
练习算法题:双指针 -cpp
c++·算法·leetcode·1024程序员节
Nuanyt1 小时前
Hot 100 刷题笔记 · 数组与哈希专题(3 题)
java·笔记·算法·leetcode·哈希算法·1024程序员节
碧海银沙音频科技研究院2 小时前
基于炬芯平台ATS308X多模型兼容语音识别算法
人工智能·算法·语音识别
爱读书的小胖2 小时前
LeetCode 274 H 指数 C 语言解题分析
c语言·算法·leetcode·1024程序员节
basketball6162 小时前
动态规划第一章:引论
算法·动态规划·1024程序员节
星夜离尘562 小时前
MATLAB 因果采样保持:用历史匹配和数据年龄防止未来信息泄漏
数据结构·算法·matlab
思麟呀3 小时前
BTree的原理与 C++ 完整实现
c语言·数据结构·c++·算法·1024程序员节
黄俊懿3 小时前
【架构师从入门到进阶】第七章:缓存和存储的优化思路——第一节:缓存概述
数据结构·数据库·分布式·缓存·架构·系统架构·1024程序员节
Tsuki_tl4 小时前
【优选算法 — 双指针】经典例题题解+算法总结
算法·蓝桥杯·力扣·刷题·双指针·1024程序员节·优选算法